%define anolis_release 6
%bcond_without tests
%global pypi_name ply

Name:           python-%{pypi_name}
Summary:        Python Lex-Yacc
Version:        3.11
Release:        %{anolis_release}%{dist}
License:        BSD
URL:            http://www.dabeaz.com/%{pypi_name}/
Source0:        http://www.dabeaz.com/%{pypi_name}/%{pypi_name}-%{version}.tar.gz

BuildArch:      noarch

%description
PLY is a zero-dependency Python implementation of the traditional parsing tools
lex and yacc. It uses the same LALR(1) parsing algorithm as yacc and has most
of its core features. It is compatible with all modern versions of Python.

PLY was originally created in 2001 to support an Introduction to Compilers
course at the University of Chicago. As such, it has almost no features other
than the core LALR(1) parsing algorithm. This is by design--students should be
made to suffer. Well, at least a little bit. However, from a more practical
point of view, there is a lot flexibility in terms of how you decide to use it.
You can use PLY to build Abstract Syntax Trees (ASTs), simple one-pass compilers,
protocol decoders, or even a more advanced parsing framework.

%package -n python%{python3_pkgversion}-%{pypi_name}
Summary:        Python Lex-Yacc
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}
BuildRequires:  python%{python3_pkgversion}-devel python%{python3_pkgversion}-six

%description -n python%{python3_pkgversion}-%{pypi_name}
PLY is a zero-dependency Python implementation of the traditional parsing tools
lex and yacc. It uses the same LALR(1) parsing algorithm as yacc and has most
of its core features. It is compatible with all modern versions of Python.

PLY was originally created in 2001 to support an Introduction to Compilers
course at the University of Chicago. As such, it has almost no features other
than the core LALR(1) parsing algorithm. This is by design--students should be
made to suffer. Well, at least a little bit. However, from a more practical
point of view, there is a lot flexibility in terms of how you decide to use it.
You can use PLY to build Abstract Syntax Trees (ASTs), simple one-pass compilers,
protocol decoders, or even a more advanced parsing framework.

%package doc
Summary:        Documentation files for %{name}
Requires:       python%{python3_pkgversion}-%{pypi_name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -n %{pypi_name}-%{version}
find example/ -type f -executable -exec chmod -x {} ';'
find example/ -type f -name '*.py' -exec sed -i \
  -e '1{\@^#!/usr/bin/env python@d}' -e '1{\@^#!/usr/local/bin/python@d}' \
  {} ';'
rm -rf *.egg-info
grep -B1000 "POSSIBILITY OF SUCH DAMAGE" README.md > LICENSE

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files %{pypi_name}

%if %{with tests}
%check
pushd test
  ./cleanup.sh
  %{__python3} testlex.py
  %{__python3} testyacc.py
  %{__python3} testcpp.py
popd
%endif

%files -n python%{python3_pkgversion}-%{pypi_name} -f %{pyproject_files}
%license LICENSE

%files doc
%doc CHANGES README.md

%changelog
* Tue May 14 2024 Bo Ren <rb01097748@alibaba-inc.com> - 3.11-6
- update source

* Tue Mar 12 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 3.11-5
- Rebuild with python3.11

* Sun Apr 09 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 3.11-4
- Optimize the spec file

* Mon Feb 27 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.11-3
- optimise dependency
 
* Sun Oct 09 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.11-2
- add doc package

* Tue Apr 19 2022 Zhongling He <zhonglingh@linux.alibaba.com> 3.11-1
- Init package from upstream v3.11
